function getPolygonCenter(vertices)
  local x, y = 0, 0
  for i = 1, #vertices, 2 do
    x = x + vertices[i]
    y = y + vertices[i + 1]
  end
  return x / (#vertices / 2), y / (#vertices / 2)
end

--[[
function getPolygonRotation(vertices)
  local angleSum = 0
  for i = 1, #vertices, 2 do
    local nextIndex = i + 2
    if nextIndex > #vertices then nextIndex = 1 end
    local v1x, v1y = vertices[i], vertices[i + 1]
    local v2x, v2y = vertices[nextIndex] - v1x, vertices[nextIndex + 1] - v1y
    angleSum = angleSum + math.atan2(v2y, v2x)
  end
  return angleSum / (#vertices / 2)
end


function setPolygonRotation(vertices, angle)
  local centerX, centerY = getPolygonCenter(vertices)
  for i = 1, #vertices, 2 do
    local x, y = vertices[i] - centerX, vertices[i + 1] - centerY
    vertices[i] = x * math.cos(angle) - y * math.sin(angle) + centerX
    vertices[i + 1] = x * math.sin(angle) + y * math.cos(angle) + centerY
  end
end
]]


local polygon = {
  50, 50,
  100, 75,
  75, 125,
  25, 100
}

local sprite = love.graphics.newImage("texture.jpg")
local cx, cy = getPolygonCenter(polygon)
local sprite_angle = 0

function love.update(dt)
    sprite_angle = sprite_angle + dt
end

function love.draw()

    love.graphics.push()
    love.graphics.translate(cx, cy)
    love.graphics.rotate(math.pi/2)
    love.graphics.translate(-cx, -cy)
      
    love.graphics.stencil(function()
        love.graphics.polygon("fill", polygon)
    end, "replace", 1)
    love.graphics.setStencilTest("greater", 0)

    love.graphics.draw(
        sprite, cx, cy, sprite_angle, 1, 1,
        sprite:getWidth()/2,
        sprite:getHeight()/2
    )

    love.graphics.setStencilTest()
    love.graphics.pop()

end

